/*
 * trace.c
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 */

#include "platform.h"
#include "xk_debug.h"
#include "compose.h"

#ifdef XK_TRACE_LOCKING
static pthread_mutex_t lock;
#endif

void
xTraceLock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_lock(&lock);
#endif
}

void
xTraceUnlock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_unlock(&lock);
#endif
}

void
xTraceInit(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_init(&lock, NULL);
    initTraceLevels();
#endif
}
