/*
 * @COPYRIGHT@
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * @COPYRIGHT@
 *
 * $RCSfile: ev4.h,v $
 *
 * HISTORY
 * $Log: ev4.h,v $
 * Revision 1.1  1996/01/30  22:55:35  slm
 * Initial revision
 *
 * Revision 1.2.1.1  1994/12/03  00:00:29  hkaram
 * New branch
 *
 * Revision 1.2  1994/11/20  01:33:15  davidm
 * Interface changed slightly due to optimizations.
 *
 * Revision 1.1  1994/07/04  17:55:13  davidm
 * Initial revision
 *
 */
#ifndef ev4_h
#define ev4_h

/* the following defines must match the code in ev4.c: */

#define NUM_EVENT_SOURCES	16	/* must be a power of two */

#define EV4_PERFMON_ON	(-1)
#define EV4_PERFMON_OFF	(-2)

#define EV4_ISSUES	(1<<0)
#define EV4_DRY		(1<<1)
#define EV4_LOADS	(1<<2)
#define EV4_FROZEN	(1<<3)
#define EV4_BRANCH	(1<<4)
#define EV4_PALMODE	(1<<5)
#define EV4_NONISS	(1<<6)
#define EV4_CNT0	(1<<7)
#define EV4_DCACHE	(1<<8)
#define EV4_ICACHE	(1<<9)
#define EV4_DUALISS	(1<<10)
#define EV4_MISPR	(1<<11)
#define EV4_FPOPS	(1<<12)
#define EV4_INTOPS	(1<<13)
#define EV4_STORES	(1<<14)
#define EV4_CNT1       	(1<<15)

#define EV4_ALL_COUNTERS	0xffff

extern void	ev4_perfmon_interrupt (void);
extern void	ev4_perfmon_ctl (int counter_mask);
extern void	ev4_perfmon_dump (void);

#endif /* ev4_h */
