/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout.h,v $
 *
 * HISTORY
 * $Log: scout.h,v $
 * Revision 1.1  1996/01/30  22:55:35  slm
 * Initial revision
 *
 * Revision 1.3.1.1  1994/12/03  00:02:18  hkaram
 * New branch
 *
 * Revision 1.3  1994/11/20  01:30:03  davidm
 * Prediction and last-call macros added.
 *
 * Revision 1.2  1994/06/11  00:02:58  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/04/22  02:11:03  davidm
 * Initial revision
 */
/*
 * General definitions.
 */
#ifndef scout_h
#define scout_h

#include <sys/types.h>

/*
 * Macro to assist in declaring the format attribute of printf/sscanf
 * like functions so that GCC can do type checking on the args:
 */
#if __GNUC__ > 1
# define FMT(a,s,f)	__attribute__ ((format (a, s, f)))
# define NORETURN	__attribute__ ((noreturn))
#else
# define FMT(a,s,f)
# define NORETURN
#endif /* __GNUC__ > 1 */

#ifndef TRUE
# define FALSE	0
# define TRUE	1
#endif

#ifdef __PREDICTIONS__
# define PREDICT_FALSE	@0
# define PREDICT_TRUE	@1
#else
# define PREDICT_FALSE
# define PREDICT_TRUE
#endif

#ifdef __LASTCALL__
# define FORCE_LASTCALL	!
#else
# define FORCE_LASTCALL
#endif

extern volatile int scout_expect_memory_access_fault;

#endif /* scout_h */
