/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_util_arch.h,v $
 *
 * HISTORY
 * $Log: scout_util_arch.h,v $
 * Revision 1.1  1996/01/30  22:55:35  slm
 * Initial revision
 *
 * Revision 1.3.1.1  1994/12/03  00:00:35  hkaram
 * New branch
 *
 * Revision 1.3  1994/11/20  01:34:53  davidm
 * Use virtual LEDs.
 *
 * Revision 1.2  1994/06/11  20:59:00  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:03:23  davidm
 * Initial revision
 */
#ifndef scout_util_arch_h
#define scout_util_arch_h

#include "scout.h"
#include "alpha_misc.h"
#include "flamingo.h"

#ifdef SCOUT_VIRT_LEDS

/*
 * The following uses the bottom right 8 pixels to emulate two
 * "LEDs" (each 4 pixels wide).  It assumes that a PMAG-BA
 * graphics board (smart frame buffer) is located in TURBOchannel
 * slot #3.  Happy hacking!
 */
#define SCOUT_LED_LAN_RX	0	/* left (green) "LED" */
#define SCOUT_LED_LAN_TX	1	/* right (red) "LED" */

/*
 * There is no explicit way to reset the LEDs as we reset them
 * automatically at every clock tick.
 */

#ifdef SCOUT_PLAY_LEDS
# define scout_set_led(l) \
{ \
    if (l == 0) { \
	*((volatile u_int*)P_TO_K0SEG(0x1603400f8)) = 0x03030303; \
    } else { \
	*((volatile u_int*)P_TO_K0SEG(0x1603400fc)) = 0x02020202; \
    } /* if */ \
}

#else
# define scout_set_led(l)
#endif

#else /* !SCOUT_VIRT_LEDS */

/*
 * The following uses the system diagnostic LEDs on the back
 * of the DEC 3000/600 etc.:
 */
#define SCOUT_LED_LAN_TX	0x01
#define SCOUT_LED_LAN_RX	0x02

/*
 * There is no explicit way to reset the LEDs as we reset them
 * automatically at every clock tick.
 */

#ifdef SCOUT_PLAY_LEDS
# define scout_set_led(l) \
    {*((volatile int*)P_TO_K0SEG(SSR)) |= (l) & 0xff;}
#else
# define scout_set_led(l)
#endif

#endif /* SCOUT_VIRT_LEDS */

#endif /* scout_util_arch_h */
