/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: turbo_channel.h,v $
 *
 * HISTORY
 * $Log: turbo_channel.h,v $
 * Revision 1.1  1996/01/30  22:55:35  slm
 * Initial revision
 *
 * Revision 1.2.1.1  1994/12/03  00:00:36  hkaram
 * New branch
 *
 * Revision 1.2  1994/06/11  00:02:56  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:03:39  davidm
 * Initial revision
 */
#ifndef turbo_channel_h
#define turbo_channel_h

#include <sys/types.h>
#include "scout_device.h"

/*
 * This is based on information published in _TURBOchannel Firmware
 * Specification_ (Digital order # EK-TCAAD-FS-004).  It should
 * be accurate for TURBOchannel Version 3.
 */

#define TC_ROM_SIGNATURE	0xffaa0055
#define TC_ROM_STRIDE			 4	/* required stride */
#define TC_OFF_ROM_HEADER	     0x3e0	/* rom header offset */
#define TC_OFF_ROM_OBJECTS	     0x480	/* first rom object */
#define TC_OFF_OLD_ROM		  0x3c0000	/* rom offset on old options */


/*
 * The following declares the ROM header assuming bytes are packed
 * densely:
 */
struct tc_rom_header {
    u_int	rom_width		: 8;
    u_int	rom_stride		: 8;
    u_int	rom_size		: 8;
    u_int	slot_size		: 8;
    u_int	rom_signature;
    char	firmware_version[8];
    char	vendor[8];
    char	module_name[8];
    char	firmware_type[4];
    u_int	flags			: 8;
};

extern void tc_config (void *base, long slot_size, int nslots,
		       Scout_IPL tc_ipl);

#endif /* turbo_channel_h */
